//+------------------------------------------------------------------+
//|                                           MTF Moving Average.mq4 |
//+------------------------------------------------------------------+

// trading rules:
   // trading TimeFrame: 1H
   // MTF: 30M - (1H)  - 4H
   
extern bool enableTrading = false;
extern bool enableSTDcheck= true;

//extern double lowerTimeFrame = 30;
extern double tradingTimeFrame=60;
//extern double higherTImeFrame= 240

extern double risk = 0.9;
extern double reward = 0.9;
int entryTF=15;

extern double lots=0.1;

extern int slowMovingPeriod = 50;
extern int fastMovingPeriod = 100;

int maxSlowTrades = 1;
//int maxFastTrades = 1;

int slowMagicNumber = 09062011;
//int fastMagicNumber = 09072011;

double slowMA1, slowMA5, slowMA15, slowMA30, slowMA60, slowMA240, slowMA1440, slowMA10080;
double fastMA1, fastMA5, fastMA15, fastMA30, fastMA60, fastMA240, fastMA1440;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
void checkConditions()
{
// slow  
   slowMA1=iMA(NULL,1,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);  
   slowMA5=iMA(NULL,5,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   slowMA15=iMA(NULL,15,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   slowMA30=iMA(NULL,30,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   slowMA60=iMA(NULL,60,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);   
   slowMA240=iMA(NULL,240,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   slowMA1440=iMA(NULL,1440,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   slowMA10080=iMA(NULL,10080,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   
   // fast
   fastMA1=iMA(NULL,1,fastMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   fastMA5=iMA(NULL,5,fastMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   fastMA15=iMA(NULL,15,fastMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   fastMA30=iMA(NULL,30,fastMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   fastMA60=iMA(NULL,60,fastMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   fastMA240=iMA(NULL,240,fastMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   fastMA1440=iMA(NULL,1440,fastMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   

   if(enableTrading==true)
   {
      if((Close[0]<=fastMA30 && Close[0]<=fastMA60 && Close[0]<=fastMA240))
      {
         // we are in a downtrend
         shortEntry();
      }  

      else if((Close[0]>=fastMA30 && Close[0]>=fastMA60 && Close[0]>=fastMA240))
      {
         // we are in a uptrend
         longEntry();
      }
   
      else
      {
         // neither up or down trend
         Comment("\n"+"no direction");
      }
   }
}

void checkSTD()
{
   
   //for(int e=7;e<=7;e++) // 7 MA(s)
   //{
      double std2M1=(2)*(iStdDev(NULL,1,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
      if(MathAbs(Close-slowMA1)>std2M1)
      {
         Comment("\n"+"1M Close is 2 standard deviaions away from MA:"+slowMovingPeriod);
      }
      
      double std2M5=(2)*(iStdDev(NULL,5,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
      if(MathAbs(Close-slowMA5)>std2M5)
      {
         Comment("\n"+"5M Close is 2 standard deviaions away from MA:"+slowMovingPeriod);
      }
      
      double std2M15=(2)*(iStdDev(NULL,15,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
      if(MathAbs(Close-slowMA15)>std2M15)
      {
         Comment("\n"+"15M Close is 2 standard deviaions away from MA:"+slowMovingPeriod);
      }
      
      double std2M30=(2)*(iStdDev(NULL,30,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
      if(MathAbs(Close-slowMA30)>std2M30)
      {
         Comment("\n"+"30M Close is 2 standard deviaions away from MA:"+slowMovingPeriod);
      }
      
      double std2H1=(2)*(iStdDev(NULL,60,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
      if(MathAbs(Close-slowMA60)>std2H1)
      {
         Comment("\n"+"1H Close is 2 standard deviaions away from MA:"+slowMovingPeriod);
      }
      
      double std2H4=(2)*(iStdDev(NULL,240,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
      if(MathAbs(Close-slowMA240)>std2H4)
      {
         Comment("\n"+"4H Close is 2 standard deviaions away from MA:"+slowMovingPeriod);
      }
      
      double std2D1=(2)*(iStdDev(NULL,1440,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
      if(MathAbs(Close-slowMA1440)>std2D1)
      {
         Comment("\n"+"1D Close is 2 standard deviaions away from MA:"+slowMovingPeriod);
      }
      
      double std2W1=(2)*(iStdDev(NULL,10080,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
      if(MathAbs(Close-slowMA10080)>std2W1)
      {
         Comment("\n"+"1W Close is 2 standard deviaions away from MA:"+slowMovingPeriod);
      }
   //}
}

void checkExposure()
{
   int ordTotal = OrdersTotal();
   double pipExposure=0;

   for (int i=0;i<=ordTotal;i++)
      {      
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);                  
         if(OrderMagicNumber()==slowMagicNumber && OrderSymbol()==Symbol())
         {
            pipExposure += MathAbs((OrderStopLoss()-OrderOpenPrice())/Point)/10;      
         }          
      }
    
    double totalExposure=0;  
    double pPoint=0;
    double totalDollarExposure=0;
    for (i=0;i<=ordTotal;i++)
      {      
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);   
         pPoint = MarketInfo(OrderSymbol(),MODE_POINT);
         if(OrderMagicNumber()== slowMagicNumber && pPoint!=0)
         {
            totalExposure += MathAbs(((OrderStopLoss()-OrderOpenPrice())/pPoint)/10);
            totalDollarExposure += (MathAbs(((OrderStopLoss()-OrderOpenPrice())/pPoint)/10))*MarketInfo(OrderSymbol(),MODE_TICKVALUE);
         }      
      }
    double equityExposure = (totalDollarExposure/AccountEquity())*100;    
      
   Comment("Symbol() PIP Exposure: "+DoubleToStr(pipExposure,1)+
           "\n"+"Total PIP Exposure: "+DoubleToStr(totalExposure,1)+
           "\n"+"Total Dollar Exposure: $"+DoubleToStr(totalDollarExposure,1)+
           "\n"+"% of Equity Exposure: "+DoubleToStr(equityExposure,1)+"%");   

}

int orderCount()
{
   int orderCnt=0;
   int openedOrders= OrdersTotal();
      for (int i=0;i<=openedOrders;i++)
      {
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(OrderMagicNumber()==slowMagicNumber && OrderSymbol()==Symbol())
         {
            orderCnt++; // add up the orders with slow magicNumber
         }
      }
      //Comment(orderCnt);
      return(orderCnt);
}


void shortEntry()
{ 
   // get 2 standard deviations range
   double slowSTD=(2)*(iStdDev(NULL,tradingTimeFrame,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
   //double fastSTD=(2)*(iStdDev(NULL,tradingTimeFrame,fastMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
   
   string orderComment=TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS);
     
   //if(Close[0]>=slowMA30 && Close[0]>=slowMA60)
   //Comment(entryTF+"M Entry Closing Price: "+iClose(Symbol(),entryTF,1));
   
   //if(iClose(Symbol(),entryTF,1)>=slowMA30) Comment("30M entry is ready");
   //if(iClose(Symbol(),entryTF,1)>=slowMA60) Comment("60M entry is ready");
   
   //Comment("Short entry, 15min price needs to close above: "+slowMA30+" and "+slowMA60);
   
   if(iClose(Symbol(),entryTF,1)>=slowMA30 && iClose(Symbol(),entryTF,1)>=slowMA60) //if price closes above the MAs on entryTF(15), then enter
   {     
      
      int orderCnt = orderCount();      
      
      if(orderCnt<maxSlowTrades)
      {         
         PlaySound("alert.wav");
         
         Comment("Entering a SHORT position");
         //OrderSend(Symbol(), OP_SELL, lots, Bid, 3,(Bid+(slowSTD*0.3)), Bid-(slowSTD*0.8), orderComment, slowMagicNumber,0,Green);
         int ticket = OrderSend(Symbol(), OP_SELL, lots, Bid, 0, 0, 0, orderComment, slowMagicNumber,0,Green);
         if(ticket>0)
         {
            OrderSelect(ticket, SELECT_BY_TICKET);
            OrderModify(OrderTicket(),OrderOpenPrice(),Bid+(slowSTD*risk),Bid-(slowSTD*reward),0,Green);
         }
      }    
   }
}

void checkSLandTP()
{
int orderCnt=0;
   int openedOrders= OrdersTotal();
      for (int i=0;i<=openedOrders;i++)
      {
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(OrderMagicNumber()==slowMagicNumber && OrderSymbol()==Symbol() && (OrderStopLoss()==0 || OrderTakeProfit()==0))
         {
            if(OrderType()==OP_SELL)
            {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Orange);
            }
            if(OrderType()==OP_BUY)
            {
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Orange);
            }
         }
      }
}


void longEntry()
{
   // get 2 standard deviations range
   double slowSTD=(2)*(iStdDev(NULL,tradingTimeFrame,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
   //double fastSTD=(2)*(iStdDev(NULL,tradingTimeFrame,fastMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
   
   string orderComment=TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS);
   
   //if(Close[0]<=slowMA30 && Close[0]<=slowMA60)
   //Comment(entryTF+"M Entry Closing Price: "+iClose(Symbol(),entryTF,1));
   
   //Comment("Long entry, 15min price needs to close below: "+slowMA30+" and "+slowMA60);
   
   if(iClose(Symbol(),entryTF,1)<=slowMA30 && iClose(Symbol(),entryTF,1)<=slowMA60) //if price closes below the MAs on entryTF(15), then enter
   {
      
      
      int orderCnt = orderCount();
      
      if(orderCnt<maxSlowTrades)
      {
         PlaySound("alert.wav");
         
         Comment("Entering a LONG position");
         //OrderSend(Symbol(), OP_BUY, lots, Ask, 3,(Ask-(slowSTD*0.3)), Ask+(slowSTD*0.8), orderComment, slowMagicNumber,0,Green);
         int ticket = OrderSend(Symbol(), OP_BUY, lots, Ask, 0, 0, 0, orderComment, slowMagicNumber,0,Green);
         if(ticket>0)
         {
            OrderSelect(ticket, SELECT_BY_TICKET);
            OrderModify(OrderTicket(),OrderOpenPrice(),Ask-(slowSTD*risk),Ask+(slowSTD*reward),0,Green);
         }
      }      
   }
}


int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
   checkSLandTP();   
   
   if(enableTrading==true)
   {
      checkConditions();
   }
      
   checkExposure();
   
   if(enableSTDcheck==true)
   {
      checkSTD();
   }
   
   return(0);
  }
//+------------------------------------------------------------------+